UNIT deletion;

INTERFACE

USES hci, population, evaluation, reproduction, definitions, crt, graph;

PROCEDURE delete_all(setup: setup_type; pop_rec: pop_rec_type;
                     VAR best_store: best_store_type;
                     VAR best_five: best_five_type);

PROCEDURE steady_delete(setup: setup_type; pop_rec: pop_rec_type;
                        VAR best_store: best_store_type;
                        VAR best_five : best_five_type);

IMPLEMENTATION

PROCEDURE delete_all(setup: setup_type; pop_rec: pop_rec_type;
                     VAR best_store: best_store_type;
                     VAR best_five: best_five_type);

    VAR new_pop : pop_type;
        pop_eval: pop_ev_table_type;
        parent1,
        parent2,
        child1,
        child2  : chromo_type;
        index,
        ave,
        gen_no  : integer;
        beeped  : Boolean;

BEGIN
  beeped := false;
  FOR gen_no := 1 TO setup.gen DO
  BEGIN
    IF keypressed THEN
    BEGIN
      restorecrtmode;
      configure_screen(blue, blue, 1);
      write_title('                    - alter mode');
      fast_setup(setup);
    END;
    FOR index := 1 TO setup.elite DO new_pop[index] := pop_rec.pop[index];
    FOR index := setup.elite + 1 TO setup.pop_size DO
    BEGIN
      mate(pop_rec, setup.pop_size, setup.cross_percent,
         setup.mut_percent, child1, child2);
      new_pop[index] := child1;
      index := index + 1;
      new_pop[index] := child2;
    END;
    pop_rec.pop := new_pop;
    pop_evaluation(setup.pop_size, pop_eval, pop_rec.pop);
    CASE setup.fitness OF
     'e' : fitness_is_evaluation(pop_eval, setup.pop_size,
                                 pop_rec.pop_fitness);
     'w' : windowing(pop_eval, setup.guard, setup.pop_size,
                     pop_rec.pop_fitness);
     'l' : linear_normalisation(pop_eval, setup.pop_size, setup.best_fitness,
                                setup.dec, pop_rec.pop_fitness);
    END;
    IF NOT beeped AND (pop_rec.pop_fitness[1, 1] = 4580) THEN
    BEGIN
      sound(440);
      delay(200);
      sound(500);
      delay(200);
      nosound;
      beeped := true;
    END;
    show_and_store(setup.results, pop_rec, setup.pop_size, gen_no,
                   setup.print_mode, best_store, best_five);
  END;
END;



PROCEDURE steady_delete(setup: setup_type; pop_rec: pop_rec_type;
                        VAR best_store: best_store_type;
                        VAR best_five: best_five_type);

    VAR new_pop : pop_type;
        pop_eval: pop_ev_table_type;
        parent1,
        parent2,
        child1,
        child2  : chromo_type;
        index,
        ave,
        gen_no,
        count   : integer;
        beeped  : Boolean;

BEGIN
  beeped := false;
  FOR gen_no := 1 TO setup.gen DO
  BEGIN
    IF keypressed THEN
    BEGIN
      restorecrtmode;
      configure_screen(blue, blue, 1);
      write_title('                    - alter mode');
      fast_setup(setup);
    END;
    FOR count := 1 TO setup.pop_size DO
    BEGIN
      mate(pop_rec, setup.pop_size, setup.cross_percent,
           setup.mut_percent, child1, child2);
      pop_rec.pop[setup.pop_size] := child1;
      count := count + 1;
      pop_rec.pop[setup.pop_size] := child2;
      pop_evaluation(setup.pop_size, pop_eval, pop_rec.pop);
    CASE setup.fitness OF
     'e' : fitness_is_evaluation(pop_eval, setup.pop_size,
                                 pop_rec.pop_fitness);
     'w' : windowing(pop_eval, setup.guard, setup.pop_size,
                     pop_rec.pop_fitness);
     'l' : linear_normalisation(pop_eval, setup.pop_size, setup.best_fitness,
                                setup.dec, pop_rec.pop_fitness);
    END;
  END;
  IF NOT beeped AND (pop_rec.pop_fitness[1, 1] = 4580) THEN
    BEGIN
      sound(880);
      delay(200);
      nosound;
      beeped := true;
    END;
  show_and_store(setup.results, pop_rec, setup.pop_size, gen_no,
                 setup.print_mode, best_store, best_five);
  END;
END;

END.